#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_pushButton_clicked()
{
    ui->pushButton->setEnabled(false);
    ui->textBrowser->append(ui->lineEdit->text());
    ui->textBrowser->append(ui->lineEdit_2->text());
    comport[0].SerialUse(ui->lineEdit->text(),ui->lineEdit_2->text().toInt(0,10));
    timerke = new QTimer(this);
    connect(timerke, SIGNAL(timeout()), this, SLOT(income()));
    connect(timerke, SIGNAL(timeout()), this, SLOT(repaint()));
    timerke->start(100);
    futrinka=0;
}

void MainWindow::on_lineEdit_3_returnPressed()
{   QChar seged;
    char chksum=0;
    comport[0].SerialPutc('$');
    seged=ui->lineEdit_3->text().size();

    comport[0].SerialPutc(seged.toAscii());
    for(int i=0;i<((ui->lineEdit_3->text().size()));i++){
        comport[0].SerialPutc((ui->lineEdit_3->text().at(i)).toAscii());
        chksum+=(ui->lineEdit_3->text().at(i)).toAscii();
    }
    comport[0].SerialPutc(chksum);
    ui->textBrowser->append(ui->lineEdit_3->text());
    ui->lineEdit_3->setText("");
}

void MainWindow::paintEvent(QPaintEvent *e){

    QPoint point=cursor().pos();
    QRgb rgbe;
    QPen pen(111);
    QColor color(rgbe);
    QPainter painter(this);
    futrinka++;
    QPoint origo,origo2,excenter,iz1,iz2,iz3,iz4,iz5;
double x,y,z;

    const double pi=3.1415;

  /*  double M1,vl,,a=80,b=120,c=160,fi,alfa,beta,gamma;

    y=(double)cursor().pos().x()-origo.x();
    x=(double)cursor().pos().y()-origo.y();
    z=-(ui->dial->value());
    M1=hypot(-x,-y)-a;       //ez j
    vl=hypot(M1,z);         //ez j
     if(vl>(c+b)){vl=c+b-0.01;}
     if(vl<fabs(a-b)){vl=fabs(a-b);}
    gamma=acos((-(vl*vl)+(b*b)+(c*c))/(2*b*c));
    alfa=atan2(y,x);        //ez j
    fi=atan2(z,M1);         //ez j
    beta=acos((-(c*c)+(b*b)+(vl*vl))/(2*b*vl))+fi;   //ez j
    if(beta>pi-0.1){beta=pi;}
    if(beta<(- pi + 0.1)){beta=(-pi);}
*/

   // ui->textBrowser->append(QString("BETA=%1").arg((beta*180/pi), 0, 'D', 3));
   // ui->textBrowser->append(QString("GAMMA=%1").arg((gamma*180/pi), 0, 'D', 3));
   // ui->textBrowser->append(QString("FI=%1").arg((fi*180/pi), 0, 'D', 3));
//ui->textBrowser->append(QString("M1=%1").arg(M1, 0, 'D', 3));
//ui->textBrowser->append(QString("vl=%1").arg(vl, 0, 'D', 3));
//ui->textBrowser->append(QString("ALFA=%1").arg((alfa*180/pi), 0, 'D', 3));

    rgbe=(unsigned int)0xff;
    //color.fromRgb(QRgb(red));

    for(int i=0;i<4;i++)    {
        lab[i].setmech(ui->lineEdit_4->text().toDouble(),ui->lineEdit_6->text().toDouble(),ui->lineEdit_6->text().toDouble());
        origo=QPoint(600+(i/2)*200,400+((i+1)%2)*200);
        origo2=QPoint(200+(i/2)*200,400+((i+1)%2)*200);
        y=(double)cursor().pos().x()-origo2.x()+(i/2)*300-300;
        x=(double)cursor().pos().y()-origo2.y()+((i+1)%2)*300-300;
        z=-(ui->dial->value());
        lab[i].inverzkinematika(x,y,z);

    pen.setWidth(5);
    pen.setColor(Qt::green);
    // painter.setPen(pen);
    // painter.setFont(QFont("Helvetica", 8, QFont::Bold));
    painter.setPen(pen);
    // delete &rgbe;

    pen.setCosmetic(true);
    //  point=QPoint(point.x()-200,point.y()-200);
    ;
    excenter=QPoint(origo.x()+lab[i].a,origo.y());
    iz1=QPoint(excenter.x()+lab[i].b*cos(lab[i].beta),excenter.y()-lab[i].b*sin(lab[i].beta));
    iz2=QPoint(iz1.x()+lab[i].c*cos(lab[i].gamma-3.1415+lab[i].beta),iz1.y()-lab[i].c*sin(lab[i].gamma-3.1415+lab[i].beta));


    iz3=QPoint(origo2.x()+lab[i].a*sin(lab[i].alfa),origo2.y()+lab[i].a*cos(lab[i].alfa));
    iz4=QPoint(iz3.x()+(lab[i].b*cos(lab[i].beta))*sin(lab[i].alfa),iz3.y()+(lab[i].b*cos(lab[i].beta))*cos(lab[i].alfa));
    iz5=QPoint(iz4.x()+lab[i].c*cos(lab[i].gamma-3.1415+lab[i].beta)*sin(lab[i].alfa),iz4.y()+lab[i].c*cos(lab[i].gamma-3.1415+lab[i].beta)*cos(lab[i].alfa));


    painter.drawLine(iz3,origo2);
    pen.setColor(Qt::red);
    pen.setWidth(8);
    painter.setPen(pen);
    painter.drawLine(iz3,iz4);
    painter.drawLine(point,QPoint(200,200));
    pen.setColor(Qt::green);
    pen.setWidth(6);
    painter.setPen(pen);
    painter.drawLine(origo,excenter);
    pen.setColor(Qt::blue);
    pen.setWidth(7);
    painter.setPen(pen);
    painter.drawLine(iz3,iz4);
    painter.drawLine(iz4,iz5);
    painter.drawLine(excenter,iz1);
    pen.setColor(Qt::yellow);
    pen.setWidth(8);
    painter.setPen(pen);
    painter.drawLine(iz4,iz5);
    painter.drawLine(iz1,iz2);
    // painter.drawRect(QRect(iz4,QSize(c,c)));
    //painter.drawLine(QPoint(excenter.x()+(vl)*cos(fi),excenter.y()+(vl)*sin(fi)),iz1);
    //   painter.drawLine(QPoint(origo.x()+(a+M1)*sin(alfa),origo.y()+(a+M1)*cos(alfa)),origo);
    //    painter.drawLine(point,origo);
    //   painter.drawLine(QPoint((point.x()+c*cos(beta-gamma)),point.y()+c*sin(beta-gamma)),point);
}
    //ui->textBrowser->setText(QString("X=%1").arg(x, 0, 'D', 3));
   // ui->textBrowser->append(QString("Y=%1").arg(y, 0, 'D', 3));
   // ui->textBrowser->append(QString("Z=%1").arg(z, 0, 'D', 3));
    //ui->textBrowser->append(QString("ALFA=%1").arg((lab[0].servoadat_p.Alfa*180/pi), 0, 'D', 3));
}
void MainWindow::mousePressEvent(QMouseEvent *m){
}


void MainWindow::income(){
   // comport[0].SerialPutc('x');
    unsigned char chk;
    QByteArray retek;
    chk=comport[0].SerialGetc();
    if(chk=='$'){
    for(int i=0;i<62;i++){
    chk=comport[0].SerialGetc();
    retek.append(chk);
    if(1){
    }
    }
    }
    ui->textBrowser->append(retek);
    comport[0].SerialPutc('');
}


void MainWindow::on_Roll_valueChanged(int value)
{
    lab[0].roll=(double)ui->Roll->value();
}

void MainWindow::on_Yaw_valueChanged(int value)
{
    lab[0].yaw=(double)(ui->Yaw->value());
}
